% file fol6g.p: let f be a binary relation on some domain.
% if f is a bijective function on that domain, also its inverse is.

fof(goal, conjecture, (bijective_function_f & inverse_f_g) => bijective_function_g).

% atomic predicate apply(f,X,Y): "tuple (X,Y) is in binary relation f" (aka "f(X)=Y")

fof(a1, axiom, bijective_function_f <=> (
  (![X]:(?[Y]:(apply(f,X,Y)))) &
  (![X,Y1,X2]:((apply(f,X,Y1) & apply(f,X,Y2)) => Y1=Y2)) &
  (![Y]:(?[X]:(apply(f,X,Y)))) &
  (![X1,X2,Y]:((apply(f,X1,Y) & apply(f,X2,Y)) => X1=X2))
)).

fof(a2, axiom, inverse_f_g <=>
  ![X,Y]:(apply(f,X,Y) <=> apply(g,Y,X))).
  
fof(a3, axiom, bijective_function_g <=> (
  (![X]:(?[Y]:(apply(g,X,Y)))) &
  (![X,Y1,X2]:((apply(g,X,Y1) & apply(g,X,Y2)) => Y1=Y2)) &
  (![Y]:(?[X]:(apply(g,X,Y)))) &
  (![X1,X2,Y]:((apply(g,X1,Y) & apply(g,X2,Y)) => X1=X2))
)).